\documentclass[12pt,preprint]{/Users/rmason/aastex52/aastex}
\def\deg{\hbox{$^{\:\circ}$}}

\begin{document}

\title{XDGNIRS v2.2.6}
\author{Rachel Mason}
\today
\maketitle

\tableofcontents

\section{Introduction}
\label{intro}

This document describes the reduction of GNIRS cross-dispersed (XD) data with the ``XDGNIRS'' pipeline (v2.2.6). The pipeline, which was created for reduction of spectra of bright, extended galaxies  (see Mason et al. 2015, ApJS, 217, 13), is able to take a list of science and calibration files, identify the file types, reduce the data, and output a flux-calibrated 1D spectrum, with various degrees of manual intervention as desired by the user. The XDGNIRS pipeline was written to handle data acquired using GNIRS' popular 32 l/mm cross-dispersed mode in the particular configuration outlined in Table \ref{obs}. In addition, it has been generalised to accept data taken without nodding off the slit to blank sky. The pipeline may work with other cross-dispersed configurations (e.g. AO observations using the long camera and 10 l/mm grating), but this has not been properly tested. 

This manual is intended for two audiences: people with GNIRS XD data who might like to try using it to reduce their own data, and Gemini staff evaluating the use of the code to produce automated ``quick-look" reductions of queue data. All potential users are encouraged to familiarise themselves with the reduction of the test data set (illustrated in this manual) before attempting to run the pipeline on other data.

More explanation of the principles behind each step in the reduction of XD data, with example images and specific IRAF task parameters, can be found on this web page:  www.gemini.edu/sciops/instruments/\ gnirs/data-format-and-reduction/reducing-xd-spectra (referred to as the ``GNIRS XD DR page'' from now on). We recommend reading that page before, or in conjunction with, this document. 

The basic architecture of XDGNIRS was set up by Omaira Gonz\'{a}lez-Mart\'{i}n, and the code was completed, tested and documented by Rachel Mason, with input from Emma Hogan, Tom Geballe, Andrew McNichols, Alberto Rodr\'{i}guez-Ardila, Daniel Ruschel Dutra, Jen Miller, and Michael Pohlen. OGM is the author of the ``REDCAN'' IDL pipeline for reduction of mid-IR imaging and spectroscopy from CANARICAM on the GTC (Gonz\'{a}lez-Mart\'{i}n et al. 2013, A\&A, 553, 35). REM claims no programming expertise and cannot be held responsible for negative emotional states that may result from looking at her code.

\begin{deluxetable}{ccccccccc}
\tablecaption{Observational Setup\label{obs}}
\tablewidth{0pt}
\tablehead{\colhead{Object} & \colhead{Camera} & \colhead{Grating} & \colhead{Prism} & \colhead{Slit} & \colhead{Dither pattern} }
\startdata
Science target & SB (0.15\arcsec/pix) & 32 l/mm & SXD & 0.3\arcsec & 3 x ABBA, q = 0\arcsec, 50\arcsec \tablenotemark{a} \\
Standard star & SB (0.15\arcsec/pix) & 32 l/mm & SXD & 0.3\arcsec &  2 x ABBA, q = 1\arcsec, -2\arcsec \\
\enddata
\tablenotetext{a}{\small Extended galaxies; unguided offset to blank sky}
\end{deluxetable}

\clearpage

\section{Code, Access and Requirements}
\label{get}

\subsection{The Code}

The main program in XDGNIRS, XDpiped.csh, is a ``wrapper'' script that calls various other python and shell scripts. The python scripts in turn call various PyRAF tasks in the Gemini GNIRS data reduction package. XDGNIRS has been tested with Ureka v1.5.1 and v1.5.2, which contain version 1.13 of the Gemini IRAF package. {\bf We have found that the most reliable performance is achieved using the ``Ureka'' installations of IRAF, PyRAF and python. We highly recommend installing this software before using XDGNIRS}. Ureka is an easy-to-install package created by Gemini and STScI, available here: http://ssb.stsci.edu/ureka. 

Users who decide not to use Ureka and are using Gemini IRAF v1.11 will need to install the v11.1.1 patch to avoid the code crashing (and we haven't tested XDGNIRS with v1.11 since many version ago, so it may crash anyway). See the instructions at www.gemini.edu/sciops/data-and-results/processing-software/download.

The parameters of the Gemini IRAF tasks have been selected to generally work well on ``normal'' XD data sets, but if necessary they could be changed by directly editing the calls to the tasks in the *py scripts. This manual describes how to run XDGNIRS; for help with the individual IRAF tasks, please see the GNIRS XD DR page and IRAF's command-line help.

The XDGNIRS code and example data can be obtained from Dropbox. Three files are available:

1) https://dl.dropboxusercontent.com/u/30608926/XDGNIRS\_V2.2.6.tar.gz: The code and this documentation

2) https://dl.dropboxusercontent.com/u/30608926/example\_data.tar.gz: The raw example data and a reduced spectrum in fits, txt and pdf format. Use this if you want to simply run the code and reproduce these results.

3) https://dl.dropboxusercontent.com/u/30608926/example\_reduction.tar.gz: All of the intermediate steps and reduced products. Download this to follow along with the example in this manual, and for future troubleshooting etc.


Assuming you already have python/Gemini IRAF/PyRAF available, installing the pipeline involves simply unpacking the tar file and adding a couple of lines to your .bashrc or .cshrc file (see the ``README.txt" file for instructions). As described on the GNIRS Status and Availability web page\footnotemark, observers using Gemini IRAF v1.11.1 to reduce data obtained after June 2012 need to use certain updated IRAF configuration files. These files are included with XDGNIRS, are automatically used where appropriate, and need not be downloaded separately. The ``cleanir'' python script is also included with XDGNIRS (see \S\ref{clean}). 

\footnotetext{www.gemini.edu/sciops/instruments/gnirs/status-and-availability; 21 Dec 2012 and 15 Nov 2012 updates}

\subsection{The Data}
\label{data_reqs}

XDGNIRS needs the following data, and will probably crash if any of these files are missing or do not comply with the listed criteria:

\noindent $\bullet$ Science target acquisition images \\
                 \hspace*{5mm} -- Target name in headers (OBJECT keyword) must be identical to target name in spectroscopy file headers \\
                 \hspace*{5mm} -- Means that blind offset observations cannot be reduced without first editing the headers \\
                 \hspace*{5mm} -- Only the final acq. image in the sequence is strictly necessary (the acq. images are only needed because of the telescope position information in the file headers) \\
\noindent $\bullet$ Science target spectroscopy files \\
                 \hspace*{5mm} -- At least two object-sky pairs \\
                 \hspace*{5mm} -- ABBA, ABA, or (probably) ABAB nod pattern \\
                 \hspace*{5mm} -- ABB$^\prime$A$^\prime$ or other patterns with $>$2 positions will not be handled properly \\
                 \hspace*{5mm} -- Nod along slit or off to blank sky \\
                 \hspace*{5mm} -- Must contain a ``q" offset (as well as or instead of ``p'' offset) \\
\noindent $\bullet$ Standard star acquisition images \\
                 \hspace*{5mm} -- Same criteria as for science target acq. images \\
\noindent $\bullet$ Standard star spectroscopy files \\
                  \hspace*{5mm} -- {\em One} standard star observation only \\
                  \hspace*{5mm} -- Same criteria as for science target spectroscopy \\
\noindent $\bullet$ One or more arcs \\
\noindent $\bullet$ A set of IR and QH flats \\
\noindent $\bullet$ One or more pinhole flats 

All of these are acquired as standard for GNIRS XD queue observations. Note that the code can currently only deal with {\em one} standard star and {\em one} science target data set at a time. If you have an observation of a single target split over $>$1 epoch (including re-acquisitions on the same night), you will need to reduce each segment separately. If you have two standard stars, you can either use only one, or repeat the reduction with both standards and see which one works better. Combining standards is not supported.

Sometimes the observer will have adjusted the exposure time of the standard star to avoid saturation or increase the signal. In this case, only the files with the appropriate exposure time should be given to XDGNIRS (although the code will attempt to flag deviant exposure times and exit if any are found). 


\section{Inspecting Your Input Data}
\label{inspect}

Given a list of science and calibration files (\S\ref{data_reqs}), the XDGNIRS pipeline can identify the data types and perform a full reduction. Some checks are performed along the way, and these are described in the relevant sections of this document. However, it is advisable to at least do a quick visual inspection of the data before entrusting the reduction to the pipeline. The GNIRS XD DR page gives more information and some examples. The Quality Assessment (QA) state of each file, also described on the above web page, should be noted as well. Files set to ``USABLE" should not be included in the reduction unless the user is sure he/she knows what they're doing. Files set to ``FAIL" almost certainly should not be used.


\section{Running the Pipeline (aka ``if you don't read anything else'')}
\label{run}

Once installed (see the README.txt file), XDGNIRS is run by typing the ``xdpiped'' command, plus a list of options. At a minimum, XDGNIRS needs a list containing the names of the files on which it will operate. It also needs to know if you're using v1.11.1 of the Gemini IRAF package (as opposed to newer versions, the default assumption). For example, to run the script in the same directory as the raw data files with no user interaction:

\begin{verbatim}
ls *fits > inputfiles.lst
xdpiped inputfiles.lst
\end{verbatim}
OR
\begin{verbatim}
xdpiped inputfiles.lst gemiraf_ver=1.11.1 ureka=no
\end{verbatim}

The input file list must contain all the science, acquisition and calibration data needed for the reduction (\S\ref{data_reqs}). The files do not need to be sorted according to the data type; the code will take care of that (\S\ref{id}). 

The available options can be seen by typing

\begin{verbatim}
xdpiped -h
\end{verbatim}

In v2.2.6 these are (with defaults):

\begin{verbatim}
rawdir: (./)  [location of raw data]
step: 0-13 (0)  [step at which to start the reduction]
stop: 0-13 (13)  [step after which to stop the reduction]
cleanir_sciflag: nfrq (f) [whether/how to run cleanir.py on the science target spectra]
cleanir_stdflag: nfrq (f) [whether/how to run cleanir.py on the standard star spectra]
cleanir_arcflag: nfrq (n) [whether/how to run cleanir.py on the arc spectra]
cleanir_IRflag: nfrq (n) [whether/how to run cleanir.py on the IR flat spectra]
cleanir_QHflag: nfrq (n) [whether/how to run cleanir.py on the QH flat spectra]
cleanir_pinflag: nfrq (n) [whether/how to run cleanir.py on the pinhole flat spectra]
nsflat_inter: yes/no (no) [run nsflat interactively?]
despike_tgt: yes/no (yes) [attempt to remove spikes from science target data?]
despike_std: yes/no (no) [attempt to remove spikes from standard star data?]
tgt_thresh: (20) [threshold for removing spikes from science target data]
std_thresh: (50) [threshold for removing spikes from standard star data]
nssdist_inter: yes/no (no) [run nssdist interactively?]
nswav_inter: yes/no (no) [run nswavelength interactively?]
nsfit_inter: yes/no (no) [run nsfitcoords interactively?]
nsext_inter: yes/no (no) [run nsextract interactively?]
aperture: 1-40 (6) [extraction aperture, pixels (+/-)]
extras: yes/no (no) [extract full-slit spectrum and in steps along the slit?]
columns: 1-40 (6) [width of each extraction step along the slit (pixels)]
hlines: vega/linefit_auto/linefit_manual/vega_tweak/linefit_tweak/none (linefit_auto) 
  [technique for removing H lines from standard star]
telluric1_inter: yes/no (no) [run `telluric' interactively when using vega_tweak 
  option?]
telluric2_inter: yes/no (no) [run `telluric' interactively when dividing by standard
  star?]
continuum_inter: yes/no (no) [interactive continuum fitting?]
offsets: no/manual (no) [enter specplot, edit order scaling?]
shift_to_rest: yes/no (no) [look up redshift and shift to rest frame?]
error_spectrum: yes/no (no) [generate S/N and error spectra? Only works on data nodded
  off the slit]
gemiraf_ver: 1.11.1/1.12+ (1.12+) [User's Gemini IRAF version]
ureka: yes/no (yes) [Use Ureka installation of IRAF/PyRAF/python?]
\end{verbatim}

These are explained in more detail in the relevant sections of this document. XDGNIRS is often able to produce a useful quick-look spectrum with no user intervention. Fairly frequently, however, the user will need to adjust the radiation event detection thresholds before a sensible result is obtained. Faint targets will probably require manual extraction. Science-quality reductions will normally also involve interactive removal of intrinsic lines in the telluric standard, and perhaps interactive optimisation of the telluric line removal. To really get to know your data, try saying ``yes'' to all interactive options. Error handling is somewhat ad-hoc and limited; we have attempted to make the script stop tidily upon encountering problems that we have encountered during testing, but that may not always be the case.

A full reduction takes in the region of 20 minutes on REM's MacBook Air. The most time-consuming pieces are steps 2 and 5 (preparing and transforming the data). The code can be interrupted at any time with a ctrl-C. 

\section{The Reduction Steps}
\label{example}

In the rest of this document we'll use the example data mentioned in  \S\ref{get} to illustrate the reduction. These are spectra of NGC~3031 (M81), a nearby galaxy with emission filling the slit.

It would probably be a good idea to initialise your IRAF uparm directory (i.e., remove all the files from it) before starting the process. We will then create an input file list and then run XDGNIRS like this (on your command line, not from within IRAF/PyRAF). We'll assume that the raw data are in a directory called ``example\_data'', and we would like to do the reduction in a directory called ``example\_reduction''.

\begin{verbatim}
cd example_data
ls N*fits > inputfiles.lst
cd ../example_reduction
mv ../example_data/inputfiles.lst .
xdpiped inputfiles.lst  rawdir=../example_data despike_std=yes shift_to_rest=yes 
\end{verbatim}

The impatient reader can run the above command and then look at the resulting ``NGC3031.fits'' and/or ``NGC3031\_data\_sheet.pdf'' files to see the final result. Alternatively, use the ``step'' and ``stop'' options to run one step at a time and follow along with the manual. The available steps can be seen by typing

\begin{verbatim}
xdpiped -h
\end{verbatim}

In v2.2.6 they are:

\begin{verbatim}
0: Identify files and create lists
1: Clean the data with cleanir.py
2: Prepare the data (with nsprepare) and measure some statistics
3: Make the flatfield
4: Reduce the science target and standard star data (de-spike, flatfield, 
   and sky subtract)
5: Rectify and wavelength-calibrate the data
6: Combine the files
7: Extract spectra
8: Remove the H lines in the standard star
9: Perform the telluric line cancellation
10: Flux calibrate the science target spectrum
11: Combine the orders
12: Create an error spectrum
13: Create an informational PDF file
\end{verbatim}

%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{Identifying the Input Files (Step=0)}
\label{id}

\noindent {\bf Relevant code:} XDpiped.csh, ObsIdentifyXD.py, mklistXD.csh, FindSpectra.py

\noindent {\bf Relevant options:} None

\noindent {\bf What it does:} The first step in the process is to identify the types of files in the user-supplied list, and make sub-lists of each type of data. This is done by the Obsidentify.py and mklistXD.csh modules, which create various lists in the LISTS subdirectory (target.lst, QH.lst, etc.). At this point the code also figures out whether the telescope was nodded along the slit or off to blank sky, does a few basic checks on the input data (e.g. checks for changes in exposure time/coadds, non-existent files, etc.), and records information about the telescope offsets that will be needed in steps 7 and 13. Some of this relies on the Observation Classes (OBSCLASS) being correct in the headers, which should be the case if the observations were set up following the GNIRS OT library or template observations. 

\noindent {\bf What to look for:} This usually works fine. If you're curious or suspect problems, check that the contents of the .lst files in the LISTS directory are what you would expect, based on the files you specified.

\noindent {\bf Most likely things to go wrong:} Usually, the code exits with an intelligible error if problems (missing files, bad headers, ...) are encountered. As noted in \S\ref{data_reqs}, XDGNIRS expects the OBJECT keyword to be identical in the acquisition and spectroscopy files for a given object (science target or standard star). If that is not the case, it will think it doesn't have the data necessary to continue, so you may have to edit the file headers. If the code exits or crashes for reasons you don't understand, maybe you've encountered a subtle feature of the headers that would require the grep (or other) syntax in mklistXD.csh to be changed.

\subsection{Pattern Noise Cleaning (Step=1)}
\label{clean}

\noindent {\bf Relevant code:} XDpiped.csh, cleanir.py

\noindent {\bf Relevant options:} \vspace{-5mm}
\begin{verbatim}
cleanir_sciflag: nfrq (f) [whether/how to run cleanir.py on the science target 
   spectra]
cleanir_stdflag: nfrq (f) [whether/how to run cleanir.py on the standard star 
   spectra]
cleanir_arcflag: nfrq (n) [whether/how to run cleanir.py on the arc spectra]
cleanir_IRflag: nfrq (n) [whether/how to run cleanir.py on the IR flat spectra]
cleanir_QHflag: nfrq (n) [whether/how to run cleanir.py on the QH flat spectra]
cleanir_pinflag: nfrq (n) [whether/how to run cleanir.py on the pinhole flat 
   spectra]
\end{verbatim}

\noindent {\bf What it does:} By default, the science target and standard star data are ``cleaned'' of electronic pattern, with XDpiped.csh acting as a wrapper for the cleanir.py script\footnote{http://www.gemini.edu/sciops/instruments/niri/data-format-and-reduction/cleanir}. The 2013 Jun 22 version of cleanir.py is supplied as part of the XDGNIRS package. The cleaning script can be run in a number of ways, using the options shown above. The default, ``f'', means that subtraction of the pattern is forced, rather than only being applied if the code detects an improvement in the rms after the cleaning. See this web page for more information and an explanation of the ``r'' and ``q'' options: www.gemini.edu/sciops/instruments/gnirs/data-format-and-reduction/cleanir-removing-electronic-pattern-0. 

The cleaned files are given the prefix ``c'' (e.g. cN20111204S0339.fits) and are saved in the INTERMEDIATE subdirectory. Setting ``cleanir\_flag=n'' causes the code to skip the cleaning step altogether, but files with the ``c'' prefix are still written (actually, symbolic links are created).

\noindent {\bf What to look for:} The user is advised to visually inspect the cleaned data files.   A limitation of XDGNIRS is that it uses the same option on all the files if a certain type (e.g. all the standard star files).  If certain files turn out to need special treatment, workarounds include (1) excluding those files from the input file list, or (2)  deleting the cleaned file, running cleanir.py on it outside the pipeline, and restarting XDGNIRS from step 2 (\S\ref{nsprepare}).

\noindent {\bf Most likely things to go wrong:} The cleaning script generally works well, but can occasionally give odd results that can affect the rest of the reduction in unexpected ways. In step 2 (\S\ref{nsprepare}), image statistics are written into the PRODUCTS/XDGNIRS\_Log.txt file. If anomalous values are detected (for instance, if the flats have a very different mean value before and after the cleaning), a warning is written into the PRODUCTS/Checks\_and\_Warnings.txt file. If this happens, the user will need to experiment with the cleanir options until satisfactory results are obtained. 

\subsubsection{Example: NGC 3031}
\label{clean_example}

Figures \ref{pattern} shows a file with electronic striping before and after running the cleanir script. The weak pattern in file N20120305S0067 is removed effectively by the script. Low-level offsets between the array quadrants are visible after the cleaning. It may be possible to remove them by running XDGNIRS with cleanir\_sciflag=fq, but such minor offsets are unlikely to noticeably affect the final spectrum.

\begin{figure}[htb]
\includegraphics[scale=0.23, clip]{N20120305S0067_clean.jpeg}
\caption{\label{pattern} \footnotesize File N20120305S0067 (left) contains some fairly low-level electronic striping which the cleanir script effectively removes (right). The data also show a couple of ``tachyons'' (bloblike artefacts that often appear after GNIRS has been cooled to operating temperature), and ``radiation events'', cosmic ray-like hits resulting from radioactive camera lens coatings. These lenses were replaced in mid-2012. Display files N20120305S0067 and cN20120305S0067 with z1=-5 and z2=5 to reproduce this figure and inspect the data.}
\end{figure}

%\begin{figure}
%\includegraphics[scale=0.43, clip]{cN20120305S0067.jpeg}
%\caption{\label{pattern2} File N20111204S0341 shows stronger electronic pattern and quadrant offsets (z1=-5, z2=5). Calling cleanir with the -f flag removes the striping, but leaves the quadrant offsets.}
%\end{figure}


%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{Preparing the Data (Step=2)}
\label{nsprepare}

\noindent {\bf Relevant code:} XDpiped.csh, StatsandPrepareXD.py

\noindent {\bf Relevant options:} None

\noindent {\bf What it does:} All files are now ``prepared" using the {\bf nsprepare} task, called by XDpiped.csh via StatsandPrepareXD.py. As described on the GNIRS XD DR page, this finds the MDF (mask definition file) shift, flags saturated pixels, etc. The nighttime files (generally science target, standard star, flats and arcs) and daytime pinhole files are prepared separately. This is because shifts in the x position of the XD orders have been observed to occur between data taken at different times (the prism turret is not perfectly reproducible), and preparing the pinholes separately from the nighttime data allows a different shift to be applied if necessary. If a shift occurs between nighttime files, this will not be taken into account and the data may not be reduced properly\footnotemark{}. Currently there are no safeguards in place to prevent this in XDGNIRS, so the user should inspect the data before running the reduction and ensure that the orders are in the same place in the x direction, to within a few pixels, in all data taken during the night.

\footnotetext{This sometimes happened with GNIRS at Gemini North before mid-2012, when the instrument was opened for maintenance work.}

The prepared files are given the prefix ``n'' (e.g. cN20120305S0067) and are saved in the INTERMEDIATE subdirectory. StatsandPrepare.py then uses {\bf nsreduce} to ``cut'' the data, putting each spectral order into a separate file extension. The output files, which are stored in the INTERMEDIATE subdirectory, are given the prefix ``r" (e.g. rncN20120305S0067). 

This module also measures and records some statistics on the input images, recorded in the ``PRODUCTS/XDGNIRS\_Log.txt' file. The statistics can be used to determine whether any images have unusually low or high counts. For example, the first flatfield of a sequence can sometimes be affected by the tertiary mirror not being properly in position, resulting in low counts in that flat. The code looks for flats that deviate by $>$10\% from the mean of all the flats, and also raises a warning if the mean of the flats differs substantially from the expected value (although the ``expected value'' is just a rough guess at what is acceptable). The results of these checks are summarised in the PRODUCTS/Checks\_and\_Warnings.txt file.

\noindent {\bf What to look for:} If there are no shifts between the input data files this step should work without problems. However, interested users may wish to display one or more of the cut files for each type of data using the display or nxdisplay commands, to ensure that the correct region of the array has been placed into each extension. See the GNIRS XD DR page for examples of good and bad cutting. {\em All} files are cut at this stage. While this is not strictly necessary (the science target and standard star observations are cut by nsreduce later in the reduction; \S\ref{nsreduce}), it does allow all of the cut data to be inspected in one go if desired. Also, check the PRODUCTS/Checks\_and\_Warnings.txt file and, if warnings are recorded, the statistics in the PRODUCTS/XDGNIRS\_Log.txt file.

\noindent {\bf Most likely things to go wrong:} This usually works OK. If it doesn't, there is probably something unusual about the input data.

\subsubsection{Example: NGC 3031}

Figure \ref{cut} shows extension 2 (order 4) of an on-source galaxy file and a quartz halogen flat file, after the orders have been cut into separate extensions. The slit and MDF match up well in both cases (the galaxy/flat signal has not been ``chopped'' or truncated), meaning that nsprepare found the correct shift of the MDF relative to the data.

\begin{figure}[htb]
\includegraphics[scale=0.23, clip]{rncN20120305S0067_74.jpeg}
\caption{\label{cut} \footnotesize Left: file rncN20120305S0067[sci,2]. This is extension 2/order 4 of an on-source galaxy spectrum after the orders have been ``cut'' into separate extensions by nsreduce. Right: rncN20120305S0074[sci,2], ext 2/order 4 of a quartz halogen flat file after the cutting. Display these files with z1=-20 and z2=20 to reproduce this figure.}
\end{figure}

The PRODUCTS/XDGNIRS\_Log.txt file now contains the following information:

\begin{verbatim}
***CHECK: Counts in cleaned images differ by <10% from those in the raw data
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
   cN20120305S0074[1]   1046528     385.9     866.4     -371.     4719.
   cN20120305S0075[1]   1046528     390.8     877.4     -341.     7317.
   cN20120305S0076[1]   1046528     394.4     880.9     -351.    10439.
   cN20120305S0077[1]   1046528     393.1     882.8     -327.     8737.
   cN20120305S0078[1]   1046528     395.5     884.4     -341.     8292.
   cN20120305S0079[1]   1046528     394.1     885.3    -1263.     8546.
   cN20120305S0080[1]   1046528     394.6     886.2     -348.     8006.
   cN20120305S0081[1]   1046528     394.9      887.     -984.     8078.
   cN20120305S0082[1]   1046528     395.4     887.3     -375.     3968.
   cN20120305S0083[1]   1046528     395.3     887.9     -338.     8905.
   cN20120305S0068[1]   1046528     105.7     433.9     -293.     7987.
   cN20120305S0069[1]   1046528     179.7      717.     -323.     7816.
   cN20120305S0070[1]   1046528      185.     715.7     -278.     7696.
   cN20120305S0071[1]   1046528     179.1      713.     -287.     8195.
   cN20120305S0072[1]   1046528      183.     709.7     -300.     8229.
   cN20120305S0073[1]   1046528      178.     708.6     -298.     7730.
   cN20120305S0084[1]   1046528     4.901     93.81     -368.     4758.
   cN20120305S0085[1]   1046528     5.598     95.15     -372.     4894.
   cN20120305S0043[1]   1046528     18.72     104.3    -475.2     8366.
   cN20120305S0044[1]   1046528     19.89     107.9     -477.     8753.
   cN20120305S0045[1]   1046528     18.33     98.54    -433.1     8201.
   cN20120305S0046[1]   1046528     21.83     113.4    -416.6     9756.
   cN20120305S0047[1]   1046528     21.74     119.9    -432.2     8335.
   cN20120305S0048[1]   1046528     20.77     114.6     -429.     8948.
   cN20120305S0049[1]   1046528     21.79     116.9    -423.5     8378.
   cN20120305S0050[1]   1046528     21.49     118.7    -454.5     8554.
   cN20120305S0056[1]   1046528     29.46     128.1    -119.5     7824.
   cN20120305S0057[1]   1046528     5.136     96.65    -641.6     7714.
   cN20120305S0058[1]   1046528     5.288     106.4     -524.     7739.
   cN20120305S0059[1]   1046528     33.48     129.7    -110.6     7566.
   cN20120305S0060[1]   1046528     32.48     126.8    -611.8     7817.
   cN20120305S0061[1]   1046528     7.288     99.94    -582.5     7619.
   cN20120305S0062[1]   1046528     8.024     96.34    -595.7     8021.
   cN20120305S0063[1]   1046528     31.61     123.8    -398.9     7766.
   cN20120305S0064[1]   1046528     32.35     124.9    -363.1     7651.
   cN20120305S0065[1]   1046528     5.284     97.56    -863.2     7837.
   cN20120305S0066[1]   1046528     5.553     91.67    -606.6     7553.
   cN20120305S0067[1]   1046528     31.93     123.6    -637.3     7494.
***CHECK: Mean counts in QH flats looks normal (350 < mean < 450)
***CHECK: Mean counts in IR flats looks normal (140 < mean < 250)
***CHECK: No deviant QH flats detected
***WARNING: IR flat(s) with deviant counts detected; do you need to reject 
   some data?
***CHECK: No deviant IR flats detected
\end{verbatim}

The lines containing ``***CHECK'' and ``***WARNING'' are also written into the PRODUCTS/Checks\_and\_Warnings.txt file.
As can be seen from the files in the LISTS directory, files 74 - 83 are the quartz halogen flats, files 68 - 73 the IR flats, and 84 - 85 the arcs. The script warns that one of the flats has counts that differ from the rest. This is file 68 (mean=106 ADU vs $\sim$180 ADU for the others). That flat looks normal when displayed, though, so this is probably nothing to worry about. These statistics also show that the cleanir script (step 1) didn't introduce major changes in the mean counts in the data. The counts in the standard star (43-50) and galaxy (56-67) are quite stable, which will not necessarily be the case for data taken in poor conditions. The ABBA, nod-to-sky pattern is visible in the counts in the galaxy observation. 

\subsection{Making the Flatfield (Step=3)}
\label{nsflat}

\noindent {\bf Relevant code:} XDpiped.csh, MakeFlatfieldXD.py

\noindent {\bf Relevant options:} 
\vspace{-5mm}
\begin{verbatim}
nsflat_inter: yes/no  [run nsflat interactively?]
\end{verbatim}

\noindent {\bf What it does:} The next step is to create the flatfield. As described on the GNIRS XD DR page, two types of flatfield are obtained for XD data taken in this mode, and several individual spectra are acquired for each type of flat. FlatfieldingXD.py calls {\bf nsflat} which combines the data, fits a polynomial to each order, and produces a single, normalised flatfield file. This is done for each set of flats, then extension 1 of the IR flat and extensions 2-6 of the QH flat are combined into a single file called ``MasterFlat.fits", saved in the INTERMEDIATE directory. 

It is not usually necessary to create the flats interactively, but this can be done by setting nsflat\_inter=yes if desired.

\noindent {\bf What to look for:} Just display the final flat and make sure it looks OK, if you like.

\noindent {\bf Most likely things to go wrong:} Sometimes, for reasons best known to itself, nsflat crashes with a fixpix floating point error. This can usually be worked round by adjusting the value of the lthreshold parameter in the call to nsflat in FlatFieldingXD.py. In the case of a crash, XDGNIRS reruns nsflat with a couple of different values of that parameter. This is usually successful but if XDGNIRS cannot get nsflat to work after three attempts, the code exits and returns an error. We have not yet identified the underlying cause of the error, and do not currently have a fix for this. However, nsflat seems to work more reliably when the Ureka installation of IRAF, PyRAF and python are used (\S\ref{get}).



\subsubsection{Example: NGC 3031}

The flat created for NGC~3031 is shown in Figure \ref{flat}. Running imstat on this file would give results like this:

\begin{verbatim}
--> imstat MasterFlat[sci,1]
#               IMAGE      NPIX      MEAN    STDDEV       MIN       MAX
    MasterFlat[sci,1]    183960    0.9986    0.0518    0.3458     1.293
\end{verbatim}

\begin{figure}[t]
\includegraphics[scale=0.23, clip]{MasterFlat.jpeg}
\caption{\label{flat} \footnotesize MasterFlat.fits, displayed using the {\bf nxdisplay} task.}
\end{figure}

%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{Reducing the Science Target and Standard Star Data (Step=4)}
\label{nsreduce}

\noindent {\bf Relevant code:} XDpiped.csh, ReducingXD.py, AltReducingXD.py

\noindent {\bf Relevant options}:
\vspace{-5mm}
\begin{verbatim}
despike_tgt: yes/no (yes) [attempt to remove spikes from science target data?]
despike_std: yes/no (no) [attempt to remove spikes from standard star data?]
tgt_thresh: (20) [threshold for removing spikes from science target
data]
tgt_thresh: (50) [threshold for removing spikes from standard star
data]
\end{verbatim}

\noindent {\bf What it does:} At this stage, the following things take place:

\noindent - The science target data (and, optionally, the standard star) are ``cleaned'' of spikes \\
- The science target and standard star data are cut, flatfielded and sky-subtracted 

These steps are performed by the ReducingXD.py or AltReducingXD.py modules. The algorithm used to identify and remove the radiation events is described on the GNIRS XD DR page. Briefly, a ``minimum'' image is created from all the individual input files at each offset position, and pixels deviating by some multiple of the noise above the minimum image are identified as radiation events. The events are ``grown'' to include their haloes as well as the central pixels and then interpolated over using IRAF's fixpix task. The output files have the prefix ``l" (e.g. lncN20120305S0067.fits). This ``despiking'' is much more critical for data taken prior to June 2012, when one of the lenses with radioactive coatings in the SB camera was replaced, but later data do tend to contain spikes that can benefit from this procedure as well.  

Unlike in previous versions of XDGNIRS, the standard star data are by default {\it not} cleaned of spikes. This is because we judged the risk of false positives to outweigh the need to clean short exposure images, especially for non-interactive reductions. The despike\_std option allows the standard star to be treated if necessary, though.  We also briefly experimented with using the gemcrspec task, based on the LACOSMIC routine\footnotemark{}, to clean the data. We didn't obtain satisfactory results, but the interested user is welcome to uncomment lines $\sim$517-518 in XDpiped.csh and edit the gemcrspec options in AltReductingXD.py if they would like to have a try.

\footnotetext{http://www.astro.yale.edu/dokkum/lacosmic/}

The {\bf nsreduce} task is then used to cut the science target and standard star data, apply the flat, and do the sky subtraction. The resulting files have the prefix ``r'' (e.g. rlncN20120305S0067.fits). Sky frames are not explicitly supplied to nsreduce, so the task attempts to identify a sky frame for each input file based on the nod position and separation in time between the spectra.

\noindent{\bf What to look for:} {\it We highly recommend that the user inspect the mask files at this stage, to check that real signal hasn't been identified as a series of radiation events.} Problems are more likely to be encountered with bright objects and when varying weather conditions caused the signal to vary greatly among the individual files. The masks have the prefix ``bgmsk'' and can be found in the INTERMEDIATE directory. If bad masks are found, rerun the code from step=4 and set the tgt\_thresh parameter to a value higher than the default. The default threshold is simply a value that has found to work reasonably well on a number of test data sets, and users may wish to experiment with this parameter to find the best ``despiking'' of their data. If unacceptable radiation events are found to remain after this process, the bgmsk*pl files (or final, combined files) could be edited using the imedit task. (Sky subtraction does remove many lower-level spikes; see \S\ref{despike}.)

\noindent{\bf Most likely things to go wrong:} The sky-object pairing algorithm in nsreduce works well except in cases where the files are irregularly spaced, which can happen if the observer paused for clouds to pass, for example. If nsreduce can't identify sky files, XDGNIRS will exit with an error.  If the offending files happen to be at the start or end of the sequence, they could simply be omitted from the input list. Otherwise the workaround would be to run nsreduce outside the pipeline, supplying a list of sky files via the ``skyimages'' parameter (see the nsreduce help). As long as the output files follow the naming convention used by nsreduce/XDGNIRS, the code could then be restarted at the next step. The name of the file used for sky subtraction is written into the header of each resulting data file, so this can be checked if problems are suspected.


\subsubsection{Example: NGC 3031}
\label{despike}

As these data were taken before the 2012 lens replacement, they contain many radiation events and are reduced using the despike\_std=yes option (as well as the default despike\_tgt=yes).

Figure \ref{radevent} shows one of the on-source galaxy spectra before and after the radiation event removal. Most of the prominent spikes are removed by this process. As Figure \ref{masks} shows, no real signal was flagged when the default value of the tgt\_thresh parameter was used. Setting the value of that parameter to lower values causes background emission at the long-wavelength end of the K band to be identified as a series of radiation events. More commonly, spurious detections will extend along the target spectrum itself, or horizontally along sky emission lines. 

In any case, interpolating over genuine signal will make a mess of the final spectrum and should be avoided. 

As well as the bright, obvious radiation events, a number of less prominent artefacts are also visible in the data. These can be seen in Figure \ref{reduced}, which shows a close-up of the cleaned data in Figure \ref{radevent}, before and after sky subtraction. Many of these disappear when the data are sky-subtracted, and others will decrease in magnitude when the files are combined (\S\ref{nssdist}). Nonetheless, if users find ways of improving the process,  feedback would be very welcome. 

\begin{figure}[htb]
\includegraphics[scale=0.23, clip]{N20120305S0067_spikes.jpeg}
\caption{\label{radevent} \footnotesize On-source galaxy spectrum, before (left, ncN20120305S0067) and after (right, lncN20120305S0067) radiation event ``cleaning''.}
\end{figure}

\begin{figure}[t]
\includegraphics[scale=0.23, clip]{N20120305S0067_masks.jpeg}
\caption{\label{masks} \footnotesize The radiation event mask, ``bgmskN20120305S0067.pl'' created for file 67 using the default value of tgt\_thresh (left), and tgt\_thresh=5 (right). With the lower value of tgt\_thresh, signal from the galaxy has been erroneously flagged as radiation events.}
\end{figure}

\begin{figure}[t]
\includegraphics[scale=0.23, clip]{N20120305S0067_skysub.jpeg}
\caption{\label{reduced} \footnotesize Left: close-up of the data shown in Figure \ref{radevent}, after removal of radiation events (lncN20120305S0067; z1=-5, z2=75). Right: extension 6/order 8 of the same file after sky subtraction (rlncN20120305S0067; z1=-5, z2=75). The green circle identifies the same pixels of extension 6/order 8 in each case, for orientation.}
\end{figure}


%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{S-distortion Correction and Wavelength Calibration (Step=5)}
\label{nssdist}

\noindent {\bf Relevant code:} XDpiped.csh, SdistorAndWLcalibXD.py

\noindent {\bf Relevant options:}
\vspace{-5mm}
\begin{verbatim}
nssdist_inter: yes/no (no) [run nssdist interactively?]
nswav_inter: yes/no (no) [run nswavelength interactively?]
nsfit_inter: yes/no (no) [run nsfitcoords interactively?]
\end{verbatim}

\noindent {\bf What it does:} XDpiped.csh now calls the SdistorAndWLcalibXD.py module, which uses the {\bf nssdist, nswavelength, nsfitcoords} and {\bf nstransform} tasks to rectify and wavelength-calibrate the data. This is what happens:

1) nssdist is used to find and trace the pinholes in the daytime pinhole flat

2) nsfitcoords is run, using the results from nssdist, to provide the information that nstransform needs to straighten the spectral orders

3) nstransform is run on the combined arc spectra. After this step the spectral orders are vertical, but the slight tilt of the detector means that the spatial direction is still not exactly parallel to the detector rows.

4) nswavelength is run on the straightened arc, to obtain the pixel-wavelength relation. Nswavelength is called with fl\_median-, which causes it to call nsfitcoords and nstransform, and (temporarily) produce an arc with horizontal arc lines.

5) nsfitcoords and nstransform are run on the straightened arc

This series of events provides the information necessary to rectify the orders in the science target and standard star data, and then de-tilt the data so that the spatial direction is along the detector rows. Normally, nsfitcoords would be run on each individual file to provide the information necessary for nstransform to rectify the data. However, the output from nsfitcoords is based on only the arc and pinhole data, which are the same for every on-sky data file. XDGNIRS therefore contains a hack to edit the headers so as to link the data to the nsfitcoords solution from steps 2 and 5 in the database files, eliminating the need to run the task multiple times. Nstransform is still run twice on each file, first to straighten the orders and then to perform the slight de-tilting. This is a fairly complex process, and the curious user can inspect the tf* and ttf* files to see how the data change at each step\footnotemark{}.

\footnotetext{If REM were continuing to work on this code, she would want to investigate the quality of the transformations in much more depth and perhaps try to improve the procedure.}

\noindent{\bf What to look for:} Check that the final, combined files (e.g standard\_comb.fits) look reasonable. It is usually quite obvious when things have gone wrong, but sometimes more subtle problems are present, such as the slit appearing to change length by a few pixels along the order. A 1D, wavelength-calibrated arc spectrum is also generated at this stage (calibrated\_arc.fits), and can serve as a useful sanity check of the wavelength calibration. In addition, the code compares the actual wavelength coverage with the expected coverage and writes the results into the Checks\_and\_Warnings.txt file. The calculation is specifically for $\lambda_{cen}$=1.65 $\mu$m, and should be ignored for other central wavelengths.

\footnotetext{If gemiraf\_ver=1.11.1, XDGNIRS calls the version of nssdist that was released with v1.12beta, which is more robust than the previous version. The nssdist.cl code is included with the XDGNIRS files.}

\noindent{\bf Most likely things to go wrong:} Sometimes a wavelength solution is not found, (hopefully) causing the code to exit with an error. This often means that one or more of the orders has not been transformed properly. If that is the case, that order in the transformed files (ttf*fits), and/or final, combined files (target\_comb.fits, standard\_comb.fits; see \S\ref{combine}) will look odd (perhaps exhibiting what we call the ``snake effect'', which is probably self-explanatory). This can usually be fixed by restarting from this step with nssdist\_inter=yes and/or nsfit\_inter=yes, and deleting deviant points in nsfitcoords (as described on the GNIRS XD web page). 

If the transformed data look good, it may be that nswavelength is unable to automatically find a wavelength solution. Use nswav\_inter=yes to see if there is an obvious problem, and/or inspect the reduced arc files. Offsets between quadrants in the arcs can upset nswavelength, as can arcs with no lines in them (because of a problem with the arc lamp or other mechanism, an uncommon occurrence). Occasionally it's just necessary to manually identify some lines, for no obvious reason.


\subsubsection{Example: NGC 3031}

Two orders of the NGC~3031 spectra are shown in Figures \ref{trans} and \ref{trans6}, before and after running nstransform on the science data. The wavelength initially increases from top to bottom, the orders are tilted, and the sky lines are not exactly parallel to the detector rows. In the transformed data set the wavelength scale is flipped, the orders are vertical and the sky lines are horizontal to within 0.2 pixels. The short-wavelength end of order 8 has not been well rectified, but this is because the throughput in that region is low enough that even the pinhole flats have little signal. There are no useful science data in that region, so the odd shape is not a problem. The same is true for smaller portions of orders 6 and 7.

\begin{figure}[t]
\includegraphics[scale=0.23, clip]{N20120305S0067_transf.jpeg}
\caption{\label{trans} \footnotesize Extension1/order3 before and after transforming (files rlncN20120305S0067, ttfrlncN20120305S0067; z1=0, z2=200).}
\end{figure}

\begin{figure}[t]
\includegraphics[scale=0.23, clip]{N20120305S0067_transf2.jpeg}
\caption{\label{trans6} \footnotesize As for Figure \ref{trans}, but for extension 6/order 8.}
\end{figure}




%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{Combining the Files (Step=6)}
\label{combine}

\noindent {\bf Relevant code:} XDpiped.csh, CombineSpectraXD.py

\noindent {\bf Relevant options:} None

\noindent {\bf What this does:} Once the individual files have been rectified, the {\bf nscombine} task is used to combine the data into a single, average file. If the telescope was nodded along the slit (rather than off to sky), the ``B'' beam spectra are shifted before being combined with the ``A'' beam data. The standard star is assumed to be nodded along the slit, so the ``B'' beam spectra are by default shifted and combined with the ``A'' beam spectra. The files generated in this step, and written to the INTERMEDIATE directory, are ``target\_comb.fits'' and ``standard\_comb.fits''. 

\noindent {\bf What to look for:} Displaying the combined files should reveal whether the data were rectified and transformed correctly. If the observations nodded along the slit, the combined data should have a central, positive trace flanked by the two negative beams. Other patterns probably indicate the ``nscombine bug'' (see below).

\noindent {\bf Most likely things to go wrong:} Nscombine can obtain the shifts between the nod beams from either the offsets in the headers or from cross-correlation, depending on the fl\_cross. As of early 2016, there is a bug in the nscombine task that occasionally causes it to misidentify the offsets when the header method is used. Unfortunately, not all science targets are bright enough for cross-correlation to be feasible, and nscombine doesn't accept offsets as input. XDGNIRS therefore runs nscombine with fl\_cross+ and compares the calculated offsets with what it believes they should be (based on the header info written in step 0). If the offsets don't look right, XDGNIRS reruns nscombine with fl\_cross-. If the offsets still don't look right, it exits with an error. Until a fixed version of nscombine is released, users in this situation will need to either contact Gemini staff for assistance or reduce the data themselves using e.g. imshift, imcombine, etc.


\subsubsection{Example: NGC 3031}

The final, combined data sets are shown in Figure \ref{comb}. Because the telescope was nodded off the slit for the extended galaxy observations, the B beam files were not shifted and combined with the A beam files, and only a single positive trace is visible in the combined file. A much smaller nod was used for the standard star, and the positive spectrum is flanked by a pair of negative ones. As the B beam spectra were shifted before the files were combined, the positive spectrum contains all the useful science data and only a single spectrum will be extracted (\S\ref{extract}).

\begin{figure}[t]
\includegraphics[scale=0.23, clip]{combined.jpeg}
\caption{\label{comb} \footnotesize Extension 1/order 3 of the combined galaxy and standard star data sets (target\_comb, standard\_comb).}
\end{figure}


%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{Extracting the Spectra (Step=7)}
\label{extract}

\noindent {\bf Relevant code:} XDpiped.csh, ExtractSpectraXD.py

\noindent {\bf Relevant options:}
\vspace{-5mm}
\begin{verbatim}
use_apall: yes/no (no) [use apall to do a weighted extraction?]
nsext_inter: yes/no (no) [run nsextract interactively?]
aperture: 1-40 (4) [extraction aperture (+/-)]
extras: yes/no (no) [extract full-slit spectrum and in steps along the slit?]
columns: 1-40 (6) [width of each extraction step along the slit (pixels)]

\end{verbatim}

\noindent {\bf What this does:} Next, 1D spectra are extracted from each order. By default an aperture of $\pm$4 pixels ($\pm$0.6\arcsec) is used; this can be changed using the ``aperture'' parameter. The standard star and science target spectra extracted in this way are given the prefix ``v'' (e.g. ``vtarget\_comb.fits''). 

The extraction is done using the nsextract task. As the spectra have been straightened by this stage, the default is to simply extract a set of columns. Alternatively the code can call apall to do a variance-weighted extraction (use\_apall=yes). As intended, this seems to improve the S/N a little for fainter targets.  It is not the default option because we have seen it introduce artefacts into spectra of bright, extended objects, which makes it a less useful option for hands-off reductions. No background subtraction is attempted when apall is called, given the short slit and the difficulty of finding parameters that work reliably for a wide range of objects. 

To enable automated extractions of faint targets, XDGNIRS looks at the aperture centres recorded by apall in the INTERMEDIATE/database files. It assumes the standard star apertures were correctly centred, and calculates the expected positions of the science target apertures based on the relative nod offsets for the science target and standard star. If the aperture locations deviate from the expected positions by more than a few pixels, XDGNIRS re-extracts the spectra forcing the apertures to be at the expected locations. This is only done if nsext\_inter=no, so as not to override apertures defined interactively by the user. While these checks should help produce reasonable quick-look spectra, science-quality reductions of faint targets will probably require extracting them manually using the nsext\_inter=yes option.

If ``extras=yes'', spectra of the science target are also extracted in an aperture of $\pm$23 pixels (the entire slit), and in steps along the slit\footnotemark. These spectra have the prefix ``a'' and ``s'', respectively (e.g. atarget\_comb.fits, s1target\_comb.fits, s2target\_comb.fits; numbers indicate the step along the slit starting from lower pixel numbers).The full-slit extraction may fail if the target is not located near the centre of the slit, and it is intended for extended objects in which the ``B'' beam was nodded off the slit. These ``extra'' extractions have not been thoroughly tested and should be used with caution.


\footnotetext{If gemiraf\_ver=1.11.1, XDGNIRS calls the version of nsextract that was released with v1.12beta. This version fixes an undesirable feature in the interpretation of the ``upper'' and ``lower'' parameters in apall that previously prevented extracting all the way along the slit.}

\noindent {\bf What to look for:} You might like to look at the extracted orders of the science target and standard star (the vtarget\_comb and vstandard\_comb spectra). Depending on the kind of target you observed, they should look something like the examples on the GNIRS XD DR page.

\noindent {\bf Most likely things to go wrong:} The full-slit and stepwise extractions have not been extensively tested. If they appear to be causing problems, try extras=no.


\subsubsection{Example: NGC 3031}

The spectra extracted from extension 1/order 3 of the galaxy and standard star data are shown in Figure \ref{specs}. Further examples, including the remaining orders, can be found on the GNIRS XD DR page.

\begin{figure}[t]
\hspace*{-2mm}
\includegraphics[scale=0.4, clip]{Extracted_spectra.png}
\caption{\label{specs} \footnotesize Spectra extracted from extension 1/order3 of the standard star (vstandard\_comb.fits, green) and galaxy (vtarget\_comb.fits, white). Most of the features in the spectra are atmospheric absorption bands, although CO band heads appear to be present in the galaxy spectrum from about 2.3 $\mu$m.}
\end{figure}


%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{H Line Removal (Step=8)}
\label{hlines}

\noindent {\bf Relevant code:} XDpiped.csh, HlinesXD.py

\noindent {\bf Relevant options:}
\vspace{-5mm}
\begin{verbatim}
hlines: vega/linefit_auto/linefit_manual/vega_tweak/linefit_tweak/none 
   (linefit_auto) [technique for removing H lines from standard star]
telluric1_inter: yes/no (no) [run 'telluric' interactively when using vega_tweak option?]   
\end{verbatim}

\noindent{\bf What it does:} At this stage, XDGNIRS removes the intrinsic hydrogen absorption lines in the standard star. The automatic options assume that an early A-type star was observed, and the code provides semi- or fully-interactive options as well. The options are:

$\bullet$ Vega method: if hlines=vega, the {\bf telluric} task is used to shift and scale a model Vega spectrum (Figure \ref{lines}). Whether or not this is done interactively depends on the telluric\_inter flag. In either case the shift and scale values are written to LISTS/telluric\_hlines.txt, so the user can later reproduce what they did manually, if desired.

$\bullet$ Line fitting method: if hlines=linefit\_auto, the {\bf bplot} task is used, together with a list of start and end wavelengths of the H lines, to fit and subtract Lorentz profiles. The line wavelengths are given by the cur*txt files supplied with the code. They were roughly derived by eye, and the user could edit them if desired. To {\em interactively} fit and subtract Gaussian, Lorentz or multiple profiles, set hlines=linefit\_manual. This will call {\bf splot} rather than {\bf bplot}, so the user can use the ``k", ``l" and ``-" keys to fit and subtract a Lorentz profile, for example. As well as being useful for optimising the Balmer line removal, this may be a helpful option if the telluric standard wasn't an A-type star. And this can also be an opportunity to interpolate over obvious spikes, if appropriate.

Example of using the manual line fitting method:

\noindent - hit ``k'' at the left-hand side of the line \\
- hit ``l'' at the right-hand side of the line to fit a Lorentz profile \\
- hit ``-'' at the right-hand side \\
- hit ``-'' at the left-hand side to subtract the Lorentz profile \\
- hit ``r'' to see the spectrum minus the fit \\
- IMPORTANT: hit ``i'' write the corrected spectrum to a file for later use by XDGNIRS \\
- hit ``q'' to quit and move on to the next order 

Figure \ref{lines}, which shows the Vega model spectrum used if hlines=vega, may help the user distinguish between H lines and telluric absorption lines in their data.

The behaviour of splot can be kind of a pain. If you think the code is hung and isn't doing anything, make sure to click in the grey box at the bottom of the splot window, making sure that the cursor is active, before typing commands there. Splot should not prompt for the name of an output spectrum. If it does, you've done something wrong.

$\bullet$ Vega\_tweak, linefit\_tweak: With these options, the Vega or Lorentz fitting algorithm is run first, then the code enters splot so the user can inspect and edit each order. If no changes are necessary, simply hit ``q" to quit and the next order will be shown. To edit the spectra, take a look at the instructions in the previous bullet. 

$\bullet$ None: if hlines=none, the code does not attempt to remove any intrinsic lines from the standard star \\

\noindent {\bf What to look for:} To see whether the H line residuals are to your satisfaction, look at the INTERMEDIATE/ftell\_nolines* files. You can also wait until the end of the reduction and inspect the final product. The $<$target name$>$\_data\_sheet.pdf file in the PRODUCTS directory at the end of the reduction shows a (rest-frame) Vega spectrum along with the reduced science target spectrum, and the Vega spectrum is also available in FITS format as ``vega\_ext.fits" in the XDGNIRS tar file. Emission lines at the location of the absorption lines in the Vega spectrum should be carefully investigated.

\noindent {\bf Most likely things to go wrong:} This step rarely fails, exactly, but the linefit\_tweak and/or vega\_tweak options are recommended for best results.

\subsubsection{Example: NGC 3031}

Extension 2/order 4 of the standard star (vstandard\_comb[sci,2]) contains several hydrogen absorption lines as well as many telluric absorption lines (Fig \ref{lines}). It can be useful to plot an atmospheric absorption spectrum (represented in Fig \ref{lines} by the vtarget\_comb[sci,2] spectrum, although this is complicated by the presence of stellar absorption lines in the galaxy), and a model Vega spectrum (vega\_ext2, provided in the XDGNIRS tar file), to figure out which lines should be removed from the telluric standard spectrum. The bottom spectrum in Fig \ref{lines}, ftell\_nolines2, shows the results of the automated line fitting algorithm.  

\begin{figure}[t]
\hspace*{45mm}
\includegraphics[scale=0.5, clip, trim=70 0 70 0]{hlines.pdf}
\caption{\label{lines} \footnotesize Standard star spectrum (extension 2/order 4) followed by the science target spectrum, a Vega model spectrum, and the standard star spectrum with the H absorption lines removed.. }
\end{figure}


%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{Telluric Line Cancellation (Step=9)}
\label{telluric}

\noindent {\bf Relevant code:} XDpiped.csh, TelluricXD.py

\noindent {\bf Relevant options:}
\vspace{-5mm}
\begin{verbatim}
extras: yes/no (no) [extract full-slit spectrum and in steps along the slit?]
telluric2_inter: yes/no (no) [run 'telluric' interactively when dividing by standard star?]
continuum_inter: yes/no (no) [interactive continuum fitting?]
\end{verbatim}

\noindent{\bf What it does:} The code corrects the science target for telluric absorption, using the line-free standard star spectrum created in \S\ref{hlines}.

The first step in the telluric line removal is to fit a continuum to each order of the line-free standard star spectrum that was created in the previous step, and divide the spectra by the fits. This appears to give better results than using the spectra directly. The continuum fitting seems to work well without intervention, but the continuum\_inter=yes option can be used to do it interactively if desired.

The {\bf telluric} task then takes the continuum-divided spectra of the standard star, and the science target spectra, and finds the shift and scaling that (hopefully) best take out the telluric lines in the science target. This can be done interactively by setting telluric2\_inter=yes. The shift and scale values are written to LISTS/telluric\_telluric.txt so that any manual adjustment of them can be reproduced later, if desired.

At this stage, the telluric-corrected science target spectrum has some arbitrary overall shape dictated by the continuum fit to the standard star, and the telluric task has introduced a normalisation factor that differs from order to order. The normalisation is taken out and the science target spectra are divided by the standard star continuum fit.

\noindent {\bf What to look for:} It is a good idea to check that {\bf telluric} has chosen reasonable shift and scale values for your spectra. These values are written into the PRODUCTS/Checks\_and\_Warnings.txt file.

\noindent {\bf Most likely things to go wrong:} Nothing, exactly, but the results of the non-interactive reduction can often be improved.


\subsubsection{Example: NGC 3031}

Order 5/extension 3 of the NGC3031 spectrum is shown before and after telluric cancellation in Figure \ref{starlines}. The atmospheric transmission near 1.4 $\mu$m is low and it is difficult to remove these lines except when the atmospheric water column is very low. The telluric correction in the rest of the spectrum is quite good.

\begin{figure}[t]
\includegraphics[scale=0.5, clip]{telluric3.png}
\caption{\label{starlines} \footnotesize Extension 3/order 5 of the NGC 3031 spectrum, before and after (green) the automatic telluric cancellation. }
\end{figure}


%@@@@@@@@@@@@@@@@@@@@@@@@
\subsection{Flux Calibration (Step=10)}
\label{flux}

\noindent {\bf Relevant code:} XDpiped.csh, mag2mass.py, FluxCalibXD.py

\noindent {\bf Relevant options:} 
extras: yes/no (no) [extract full-slit spectrum and in steps along the slit?]

\noindent {\bf What it does:} In this step each order is multiplied by a blackbody spectrum of appropriate temperature, scaled to the K-band flux of the standard star (if known).

XDGNIRS looks for a file called INTERMEDIATE/std\_star.txt, containing the spectral type and IR magnitudes of the standard star.  The temperature corresponding to the spectral type of the standard star is then looked up in the ``starstemp.txt'' file supplied with the code\footnotemark. If std\_star.txt  does not exist, SIMBAD is queried for this information. 
Alternatively, the user can create the file following the example of the file created for NGC~3031 (the fact that the star has the same magnitude in all bands is a historical artefact from an old method of doing the flux calibration; only the K band magnitude actually needs to be correct):

\begin{verbatim} 
k K 8.083 9701
h H 8.083 9701
j J 8.083 9701
j J 8.083 9701
i J 8.083 9701
i J 8.083 9701
\end{verbatim}

\footnotetext{From www.pas.rochester.edu/$\sim$emamajek/EEM\_dwarf\_UBVIJHK\_colors\_Teff.dat. The code should really use the updated data in the apjs480616t5\_mrt.txt file, which come from Pecaut \& Mamajek 2015, but it looks like REM didn't quite finish that job. Shouldn't make a lot of difference, though.}

Each order is then multiplied by a blackbody function of the temperature specified in the std\_star.txt file. If the K band magnitude of the standard star is known, the blackbody function for extension 1/order 3 is scaled to that value (converted to F$_{\lambda}$), providing a rough absolute flux calibration. If not, only relative flux calibration is performed.  This is noted in the PRODUCTS/XDGNIRS\_Log.txt file and the flux units are written into the headers, so it's possible to tell what was done. If extras=yes, steps 4 is carried out for the full-slit and step-by-step extractions (\S\ref{extract}) as well as the ``standard'' aperture extraction. 

\noindent {\bf What to look for:} Not a lot; these simple mathematical operations should go smoothly enough.

\noindent {\bf Most likely things to go wrong:} Sometimes, if the code is interrupted at just the wrong time (or for other reasons we don't understand), INTERMEDIATE/std\_star.txt can exist but not contain the right (or any) information. If the code crashes at or after step 10, try deleting that file and rerunning from step 10. The mag2mass.py lookup code is a lot more robust than it used to be, but problems with the SIMBAD query results (or the interpretation of it) can occasionally also cause the code to crash at this stage.

\subsubsection{Example: NGC 3031}

Fig. \ref{fcal} illustrates the spectral shape of the extension 3/order 5 spectrum before and after flux calibration.

\begin{figure}[t]
\includegraphics[scale=0.5, clip]{fluxcal.png}
\caption{\label{fcal} \footnotesize Extension 3/order 5 of the NGC 3031 spectrum, before (green) and after flux calibration. }
\end{figure}


\subsection{Combining the Orders (Step=11)}
\label{telluric}

\noindent {\bf Relevant code:} XDpiped.csh, redshift.py, CombineOrders.py, gnirs\_unc.py

\noindent {\bf Relevant options:}
\vspace*{-5mm}
\begin {verbatim}
extras: yes/no (no) [extract full-slit spectrum and in steps along the slit?]
offsets: no/manual (no) [enter specplot, edit order scaling?] 
shift_to_rest: yes/no (no) [look up redshift and shift to rest frame?]
\end{verbatim}


\noindent{\bf What it does:} The individual orders are combined. This was originally done using IRAF's odcombine task. However, this resamples the spectrum to a linear dispersion, significantly oversampling some of the orders. The combination is now done using custom code written by Daniel Ruschel Dutra (see gnirs\_unc.py).

A plot of the individual orders, PRODUCTS/orders.pdf, is generated so the user can easily see offsets between orders. If significant offsets are found, the code can be restarted at this step using the offsets=manual option. This takes the user into specplot, so the scaling of individual orders can be adjusted. We suggest using this option in the following way:

1) First, set the colour of each order using commands like :color[2] 2 (to make the second spectrum red, for example). You'll need to hit "r" to redraw the plot and see the new colour scheme. This makes it easier to see if any orders are offset in y.

2) Next, put the cursor near any order you want to scale, and type :scale 0.9 (for example). It's important to know that specplot applies whatever command you give it to the spectrum nearest the cursor.

3) Repeat the previous step until you're satisfied, then hit ``q'' to quit. There's no need to write out the edited spectra, the final scaling is written into a log file by specplot and the code uses that information to scale the orders.

Especially in the higher orders, the throughput is very low in certain regions of the spectrum. The code deals with this by only passing restricted ranges of data to odcombine for combining. These pieces are specified by a file that is written into the INTERMEDIATE directory the first time the code is run. If the orders.pdf file suggests that it would be better to exclude (or include) more of any order, the user can proceed like this:

1) Look for the ``goodbits.txt" file in the INTERMEDIATE directory. That file contains the regions of each order used in the final, combined spectrum, starting with order 3/extension 1. Make a guess at the region you would like to use, and edit and save the file.

2) Run the code again, and see if you like the orders.pdf file better

3) Repeat until satisfied. To revert to the original values, simply delete the INTERMEDIATE/goodbits file and rerun the code from this step.

The final spectrum is given a name based on the target name in the original file headers. If shift\_to\_rest=yes, a rest-frame spectrum is generated based on the redshift obtained by the redshift.py code, which queries NED. The redshift is written to INTERMEDIATE/redshift.txt, like this:

\begin{verbatim}
-0.00014
\end{verbatim}

The redshift file can be created by the user if necessary. The spectra of each order, and the combined spectrum,  are also written to .txt files at this stage.

This is essentially the end of the reduction; FITS and text files containing the 1D, calibrated spectrum are created here.


\noindent{\bf Most likely things to go wrong:} Special characters in the filename can cause the code to fail. Currently the only protection against this is for the ``/" and space characters, which are removed'. Interorder offsets are most common between orders 7/8 (the shortest-wavelength orders) and are usually of the order of 10\% or less. Large interorder offsets usually indicate that something has gone wrong; probably one of the orders has been badly rectified, or maybe the correct columns weren't extracted. See sections \ref{nssdist} and \ref{extract} for what to do if this happens.


\subsubsection{Example: NGC 3031}

The ``orders.pdf'' plot generated for NGC~3031 is shown in Fig. \ref{orders}; evidently there are no large offsets between orders in this reduction. The final, rest-frame spectrum is shown in Fig. \ref{final}.

\begin{figure}[t]
\includegraphics[scale=0.8, clip]{orders.pdf}
\caption{\label{orders} \footnotesize The ``orders.pdf'' file generated for NGC~3031.}
\end{figure}

\begin{figure}[t]
\includegraphics[scale=0.46, clip]{final.png}
\caption{\label{final} \footnotesize }
\end{figure}

\subsection{Generating an Error Spectrum (Step=12)}

Not yet reliably implemented; default is to skip this step.

\noindent{\bf Relevant code:} XDpiped.csh, CalcNoiseXD.py

\noindent {\bf Relevant options:} None

\noindent {\bf What it does:} Creates a noise spectrum

\noindent {\bf Most likely things to go wrong:} Everything.

\subsection{Science Target Data Sheets (Step=13)}
\label{record}

\noindent{\bf Relevant code:} XDpiped.csh, GetInfoXD.py, WriteDataSheetXD.py

\noindent {\bf Relevant options:} None

\noindent {\bf What it does:} This part of the code makes a pdf file showing the final spectrum and recording some information such as S/N, airmass, etc. 

\noindent {\bf Most likely things to go wrong:} This step is intended to help the Palomar XD group interpret the reduced data and may not work well on other data sets. If this step causes problems, simply run the code with ``stop=11'' and use your own routines to plot the .txt or .fits files output in that step. The total counts and FWHM recorded in the data sheet may not be correct for all data sets.


\subsubsection{Example: NGC 3031}

Figure \ref{data} shows the final data sheet created for this galaxy. This spectrum was obtained with no manual intervention (except, arguably, inspecting the radiation event masks as described in \S\ref{nsreduce}). Various aspects of the reduction could be improved by re-running steps interactively (notably the standard star H line removal), but the overall result is a useful quick-look spectrum that could be used for planning future observations, for example.

\begin{figure}[t]
\includegraphics[scale=0.8, clip]{ngc3031_data_sheet.pdf}
\caption{\label{data} \footnotesize The ``data sheet'' generated for NGC~3031. The dashed blue line is a model Vega spectrum, intended to point out the locations where imperfectly removed lines in the standard star could be mistaken for real features. The ``messy'' regions around 1.4 and 1.8 $\mu$m correspond to areas of of low atmospheric transmission.}
\end{figure}


\section{What to look for}

This section lists the most important files to check at the end of a reduction, particularly a non-interactive one. They are explained and illustrated in more depth in the preceding sections; the aim of this summary is mainly to provide a quick cheat sheet for deciding whether to re-run any of the steps with manual intervention.

As well as the final spectrum, it's a good idea to look at:

\begin{itemize}
\item The PRODUCTS/Checks\_and\_Warnings.txt file. Does it contain any warnings that suggest a closer look at the reduction is warranted?  For example, large scale factors found by the telluric task might mean the telluric correction could be improved. Note that the values used to separate Checks (things look OK) from Warnings (something looks suspicious) are best guesses that may not be appropriate for all data and purposes.
\item The PRODUCTS/orders.pdf file. Are there offsets between the spectral orders, and are there regions at the end of any orders that could benefit from being omitted from the combined spectrum? See \S\ref{orders}.
\item The INTERMEDIATE/standard\_comb.fits file. Have all the orders been straightened nicely? If the standard\_comb file looks good, the target\_comb one should as well. See \S\ref{nssdist}.
\item The INTERMEDIATE/bgmsk*pl files. These masks should contain scattered points, not real structure. See \S\ref{nsreduce}.
\end{itemize}

\section{Usage/Syntax Examples}

These examples assume that the initial file list is called ``inputfiles.lst'' and that Ureka is used.

\noindent $\bullet$ Reduce a data set as far as flatfielding and sky subtraction, inspect the radiation event masks, and then restart with a different threshold value:

\begin{verbatim}
xdpiped inputfiles.lst step=0 stop=4 rawdir=../example_data 
[display and assess the bgmsk*pl files, decide on new thresholds]
xdpiped inputfiles.lst step=4 stop=4 rawdir=../example_data tgt_thresh=30 
[repeat until masks are satisfactory, then restart]
xdpiped inputfiles.lst step=5 rawdir=../example_data 
\end{verbatim}

\noindent $\bullet$ Fully reduce a data set, then improve the standard star line removal step using the semi-interactive line fitting method:

\begin{verbatim}
xdpiped inputfiles.lst step=0 rawdir=../example_data 
xdpiped inputfiles.lst step=8 rawdir=../example_data hlines=linefit_tweak
\end{verbatim}

%\section{Known issues/limitations, wishlist}

\section{Troubleshooting, Support, and Acknowledgment}
\label{trouble}

XDGNIRS is not officially supported by Gemini and the main developer, REM, is on a leave of absence through early 2017. Good luck. Feel free to manipulate the pipeline in any way that is useful to you, and distribute it however you wish.

For general questions about GNIRS data and reduction, file a helpdesk request and/or visit the Gemini data reduction forum: http://drforum.gemini.edu. There is no official paper describing XDGNIRS in depth; the closest reference is Mason et al. 2015, ApJS, 217, 13.

\section{History}

The last version of XDGNIRS to be distributed via the data reduction forum was v2.0. Changes since then have mostly been aimed at making the code easier to maintain and better at automated, ``quick-look'' reductions of a wide range of data sets. The main change that will lead to differences in output spectra is the move from using odcombine to combine the spectral orders to a custum order-combining script. See \S\ref{orders} for more information.

\section{Wishlist}

\begin{enumerate}
\item Code currently comes with various `custom'' cl files, mostly advance versions of files later released with Gemini IRAF package. Re-integrate with Gemini IRAF package.
\item More data checks, e.g. measure arc line FWHM and warn if larger than expected
\item Better despiking algorithm
\item Evaluate and maybe improve the wavelength calibration and rectification step
\item Test or remove the ``extras'' option
\item Implement and test MOLECFIT tool for correcting telluric absorption (Smette et al. 2015, A\&A, 576, 77)
\item Rewrite flux calibration to use sbands task
\item Error spectrum from propagating initial variance (or any kind of sensible error estimate)
\item List of inputs to and outputs from each step
\item Do everything in 2D and then extract spectrum as final step
\end{enumerate}

\bibliographystyle{/Users/rmason/aastex52/apj}
\bibliography{/Users/rmason/aastex52/refs}


\end{document}